/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996 
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: crc.h,v $
 * Revision 1.1.2.3  1998/06/19  01:16:57  dbender
 * 	Added CRC32_POLYNOMIAL so rom can use it.  Removed trailing 'UL' from constants
 * 	so 'as' won't complain.  Added ifdef for _IN_ASM_
 * 	[1998/06/19  01:10:30  dbender]
 *
 * Revision 1.1.2.2  1998/06/02  04:54:59  tibor
 * 	added swapw() function
 * 	[1998/06/01  23:58:51  tibor]
 * 
 * Revision 1.1.2.1  1997/03/14  06:58:11  nimisha
 * 	first entry - had forgotten to bci. :)
 * 	[1997/03/14  06:57:59  nimisha]
 * 
 * $EndLog$
 */

#ifndef _CRC_H_ 
#define _CRC_H_

#define CRC_MAGIC_VALUE     0xDEBB20E3
#define CRC32_POLYNOMIAL    0xEDB88320

#if !defined(_IN_ASM_)

extern U32 gen_crc(U8 *databuf, U32 datalen, U32 crc_in);
extern unsigned long swapw(const unsigned long data);

#ifdef CRC_DEBUG
extern bool bCRCDebug;
#endif

#endif /* !defined(_IN_ASM_) */

#endif /* _CRC_H_ */

