#
# COPYRIGHT NOTICE
# Copyright (c) Alteon Networks, Inc. 1996
# All rights reserved
#
# HISTORY
# $Log: Makefile.gnu $
# Revision api12_3_ted/2 1999/08/12 21:07:39 ted
# 	Add assembler routines
# 
# $EndLog$
#

# Local configuration stuff
# Need to set TOOLS_BASE, EXPORTBASE, and SOURCEBASE manually.

TOOLS_BASE=/usr/local/alteon-tools
EXPORTBASE=<your directory>/export/sparc_solaris
SOURCEBASE=<your directory>/src

include ../common/alt.tg1.gnu

OFILES		= start.o disp.o fwmain.o timer.o command.o mcast.o \
		dma.o trace.o data.o mem.o send.o recv.o mac.o cksum.o \
		com_link.o com_np.o com_mii.o com_zconf.o com_link_if.o \
		com_led.o recvasm.o dmaasm.o

CFILES		= fwmain.c timer.c command.c mcast.c \
		dma.c trace.c data.c mem.c send.c recv.c mac.c cksum.c \
		com_link.c com_np.c com_mii.c com_zconf.c com_link_if.c \
		com_led.c 

#
# override the defauls for clean and clobber
#
CLEANFILES	= *.list *.ss alt_fw2.map ${OFILES}

all: ${PROGRAMS} ${INCLUDES}

${PROGRAMS}: ${_OFILES_}
	${_LD_} -nostdlib -T ../common/alteon.x ${_LDFLAGS_} -o $@.X ${_OFILES_} ${_LIBS_}
#	${_LD_} -nostdlib -Ttext 0x4000 -N ${_LDFLAGS_} -o $@.X ${_OFILES_} ${_LIBS_}
	${MV} $@.X $@
	${SIZE} $@ > $@.map
	${NM} $@ | sort >> $@.map

${INCLUDES}: ${PROGRAMS}
	${GENFW} ${GENFWFLAGS} $< $@

vpath %.c ../common
.c.o:
	${_CC_} -o `basename $@ .o`.ss ${_CCFLAGS_} $<
	${AS} ${AFLAGS} -APIC -o $@ -L -a=`basename $@ \
		.o`.list `basename $@ .o`.ss 
	${RM} `basename $@ .o`.ss

vpath %.s ../common
.s.o:
	${_CC_} -x assembler-with-cpp -E -o `basename $@ .o`.ss \
		${_CCFLAGS_} $<
	${AS} ${AFLAGS} -o $@ -L -a=`basename $@ .o`.list \
		`basename $@ .o`.ss
	${RM} `basename $@ .o`.ss

data.o: ${GENNED_HDRS}

clean:
	rm -f ${CLEANFILES}

