# Solaris tools
ANSI_CC=	${TOOLS_BASE}/bin/mips-sgi-irix5.3-gcc
AS=		${TOOLS_BASE}/bin/mips-sgi-irix5.3-as
ANSI_LD=	${TOOLS_BASE}/bin/mips-sgi-irix5.3-ld
NM=		${TOOLS_BASE}/bin/mips-sgi-irix5.3-nm
ANSI_RANLIB=	${TOOLS_BASE}/bin/mips-sgi-irix5.3-ranlib
ANSI_AR=	${TOOLS_BASE}/bin/mips-sgi-irix5.3-ar
SIZE=		${TOOLS_BASE}/bin/mips-sgi-irix5.3-size
# NT tools
#ANSI_CC=	${TOOLS_BASE}/bin/mips-any-elf-gcc.exe
#AS=		${TOOLS_BASE}/bin/mips-any-elf-as
#ANSI_LD=	${TOOLS_BASE}/bin/mips-any-elf-ld
#NM=		${TOOLS_BASE}/bin/mips-any-elf-nm
#ANSI_RANLIB=	${TOOLS_BASE}/bin/mips-any-elf-ranlib
#ANSI_AR=	${TOOLS_BASE}/bin/mips-any-elf-ar
#SIZE=		${TOOLS_BASE}/bin/mips-any-elf-size
CNTXT_CFLAGS=	-mcpu=r4000 -mips2 -mno-abicalls -fverbose-asm
CNTXT_AFLAGS=	-mips2

STD_CFLAGS=	-ansi -Wall -Wshadow -Winline -S
PROTO_CFLAGS=	-Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wredundant-decls
STD_AFLAGS=	

CFLAGS=		${STD_CFLAGS} ${PROTO_CFLAGS} ${CNTXT_CFLAGS}
AFLAGS=		${STD_AFLAGS} ${CNTXT_AFLAGS}

INCLUDES	= alt_fw2.h
EXPDIR		= /usr/include/

EXPBIN_DIR	= ${EXPORTBASE}/usr/bin

#GENFW		=  ${EXPBIN_DIR}/genfw
GENFW		=  ${SOURCEBASE}/utils/genfw/genfw.exe
GENFWFLAGS	= -ptigon2 -h ${SOURCEBASE}/nic/host/common/altreg.h

PROGRAMS	= alt_fw2

#OPT_LEVEL	= -O3 -g
OPT_LEVEL	= -O3

CDEFS		= -DSBUS=0 -DTRACE=0 -DTRACE_ALL=0 -DUSE_ASM \
		-DFW_PROFILE=0 -DSCRATCH_PAD -DSCRATCH_PAD_STACK_ADJUST=1

CFLAGS		= ${CDEFS} -ansi -Wall -Wshadow -Wstrict-prototypes \
		-Wmissing-prototypes -Wmissing-declarations \
		-Wredundant-decls -fverbose-asm -Winline -mcpu=r4000 \
		-mips2 -mno-abicalls -S -DTIGON_REV=2 -fno-builtin \
		-G 0 -fno-pic

AFLAGS		= -mips2 -G 0

INCFLAGS	= -I../../../common -I../../common -I../common

GENNED_HDRS	= compile.h

_OFILES_ 	= ${OFILES}
_CC_		= ${ANSI_CC}
_CCFLAGS_	= ${OPT_LEVEL} ${CFLAGS} -DOEM_ALTEON ${INCFLAGS}
_LDFLAGS_	= ${LDFLAGS} 
_LD_		= ${ANSI_LD}
#_LIBS_		= -L${TOOLS_BASE}/lib -lgcc
#_LIBS_		=
MV=mv

build_all: all

_OBJDIR_=./
compile.h:
	@echo \#define FW_VERSION \"FW_VERSION: XXX\" >> ${_OBJDIR_}.ver
	@echo \#define FW_COMPILE_TIME \"FW_COMPILE_TIME: XXX\" >> ${_OBJDIR_}.ver
	@echo \#define FW_COMPILE_BY \"FW_COMPILE_BY: XXX\" >> ${_OBJDIR_}.ver
	@echo \#define FW_COMPILE_HOST \"FW_COMPILE_HOST: XXX\" >> ${_OBJDIR_}.ver
	@echo \#define FW_COMPILE_DOMAIN \"FW_COMPILE_DOMAIN: XXX\" >> ${_OBJDIR_}.ver
	@echo \#define FW_COMPILER \"FW_COMPILER: XXX\" >> ${_OBJDIR_}.ver
	@echo \#define FW_SANDBOX \"FW_SANDBOX: XXX\" >> ${_OBJDIR_}.ver
	@mv -f ${_OBJDIR_}.ver ${_OBJDIR_}$@

