# COPYRIGHT NOTICE
# Copyright (c) Alteon WebSystems, Inc. 1999
# All rights reserved

/* could be in nic_api.h instead of here */
/* special event stuff */
#define not_TG_FW_EVENT_RECV_BD	    -513	   # 0xfffffdff

/*
 * Stuff from tg.h but without all the cruft.  tg.h is so over
 *  preprocessed I don't think it likely that it will ever
 *  be included in here.
 * Assumes tigon2 ASIC 
 */
/* dma descriptor */
#define dd_host_addr_hi                0
#define dd_host_addr_lo                4
#define dd_nic_addr                    8
#define dd_length                     14
#define dd_state                      16
#define dd_cksum_ptr                  20
#define dd_cksum                      22
#define dd_type                       24
#define dd_index                      28
#define sizeof_dma_descr              32

/* derived from tg_data structure */
#define tdp_stack                  0
#define tdp_stack_b                4096               /* 0x1000 */
#define tdp_tx_mac_ring            10240	      /* 0x2800 */
#define tdp_tx_mac_ring_end        12280	      /* 0x2ff8 */
#define tdp_rx_mac_ring            12288	      /* 0x3000 */
#define tdp_rx_mac_ring_end        16376	      /* 0x3ff8 */
#define tdp_rd_dma_ring            16384	      /* 0x4000 */
#define tdp_rd_dma_ring_end        18400	      /* 0x47e0 */
#define tdp_wr_dma_ring            18432	      /* 0x4800 */
#define tdp_wr_dma_ring_end        20448	      /* 0x4fe0 */

#define TG_MISC_HOST_CONTROL                  0x40    /* 64 */
/* Misc. Host Control Bit definitions */
#define TG_MHC_TIGON_VERSION_MASK       0xf0000000
#define TG_MHC_CHIP_EXPRESS_VERS        0x30000000
#define TG_MHC_LSI_GATE_VERS            0x40000000
#define TG_MHC_LSI_STANDARD_CELL_VERS   0x50000000
#define TG_MHC_LSI_STANDARD_CELL_VERS_B 0x60000000
#define TG_MHC_MASK_OFF_RUPT            0x00000040
#define TG_MHC_WORD_SWAP                0x00000020
#define TG_MHC_BYTE_SWAP                0x00000010
#define TG_MHC_RESET                    0x00000008
#define TG_MHC_CLEAR_RUPT               0x00000002
#define TG_MHC_RUPT_STATE               0x00000001

#define TG_MISC_LOCAL_CONTROL                 0x44    /* 68 */
#define TG_MLC_INPUT_INTERRUPT   	0x08000000

#define TG_MLC_UART_RX_OVERRUN          0x04000000
#define TG_MLC_UART_RX_READY            0x02000000
#define TG_MLC_UART_TX_DONE             0x01000000
#define TG_MLC_UART_MASK                0x07000000 

#define TG_MLC_MII_DATA_IN       	0x00080000
#define TG_MLC_MII_DATA_OUT       	0x00040000
#define TG_MLC_MII_DATA_OUT_ENA       	0x00020000
#define TG_MLC_MII_CLK_OUT       	0x00010000
#define TG_MLC_MII_MASK			0x000f0000

#define TG_MLC_MISC_OUT_1	     	0x00008000
#define TG_MLC_MISC_OUT_0	     	0x00004000
#define TG_MLC_MISC_OUT_1_ENA     	0x00002000
#define TG_MLC_MISC_OUT_0_ENA     	0x00001000
#define TG_MLC_MISC_IN_1     		0x00000800
#define TG_MLC_MISC_IN_0     		0x00000400

#define TG_MLC_SRAM_LADDR_22            0x00008000
#define TG_MLC_SRAM_LADDR_21            0x00004000

#define TG_MLC_SRAM_BANK_DISA		0x00000000
#define TG_MLC_SRAM_BANK_1024K		0x00000100
#define TG_MLC_SRAM_BANK_512K		0x00000200
#define TG_MLC_SRAM_BANK_256K		0x00000300
#define TG_MLC_MISC_OUT_2		0x00000080

#define TG_MLC_LOOPBACK			0x00000080
#define TG_MLC_LED_DATA			0x00000040
#define TG_MLC_LED_LINK			0x00000020

#define TG_MLC_FAST_EEPROM              0x00000008
#define TG_MLC_SET_INTERRUPT            0x00000004
#define TG_MLC_CLEAR_INTERRUPT          0x00000002
#define TG_MLC_INTERRUPT_STATE          0x00000001

#define TG_MLC_SER_EEPROM_DATA_IN      	0x00800000
#define TG_MLC_SER_EEPROM_DATA_OUT     	0x00400000
#define TG_MLC_SER_EEPROM_WRITE_ENA 	0x00200000
#define TG_MLC_SER_EEPROM_CLK_OUT      	0x00100000
#define TG_MLC_SER_EEPROM_MASK      	0x00f00000

#define TG_MLC_MORE_SRAM_256K           0x00000200

#define TG_MLC_EEPROM_WRITE_ENA	        0x00000010

#define TG_SEMAPHORE_A  	              0x48    /* 72 */
#define TG_SEMAPHORE_B 		              0x4c    /* 76 */
#define TG_EVENT                              0x60    /* 96 */
#define TG_MBOX_EVENT                         0x64    /* 100 */
#define TG_DMA_WRITE_HOST_HI                  0x80    /* 128 */
#define TG_DMA_WRITE_HOST_LO                  0x84    /* 132 */
#define TG_DMA_READ_HOST_HI                   0x90    /* 144 */
#define TG_DMA_READ_HOST_LO                   0x94    /* 148 */
#define TG_DMA_READ_LEN                       0x9c    /* 156 */
#define TG_DMA_WRITE_STATE                    0xa0    /* 160 */
#define TG_DMA_WRITE_ADDR                     0xa4    /* 164 */
#define TG_DMA_WRITE_CKSM                     0xa8    /* 168 */
#define TG_DMA_WRITE_LEN                      0xac    /* 172 */
#define TG_DMA_READ_STATE                     0xb0    /* 176 */
#define TG_DMA_READ_ADDR                      0xb4    /* 180 */
#define TG_DMA_READ_CKSM                      0xb8    /* 184 */
#define TG_RECV_BUF_BASE                      0xc0    /* 192 */
#define TG_RECV_BUF_PROD	              0xc4    /* 196 */
#define TG_RECV_BUF_CONSUME                   0xc8    /* 200 */
#define TG_RECV_BUF_START		      0xcc    /* 204 */
#define TG_SEND_BUF_BASE                      0xd0    /* 208 */
#define TG_SEND_BUF_PROD                      0xd4    /* 212 */
#define TG_SEND_BUF_CONSUME                   0xd8    /* 216 */
#define TG_SEND_BUF_NEXT                      0xdc    /* 220 */
#define TG_MAC_RECV_PROD                      0xe0    /* 224 */
#define TG_MAC_RECV_CONS                      0xe4    /* 228 */
#define TG_MAC_RECV_REF                       0xe8    /* 232 */
#define TG_CPU_PRIOR			      0xec    /* 236 */
#define TG_MAC_SEND_PROD                      0xf0    /* 240 */
#define TG_MAC_SEND_CONS                      0xf4    /* 244 */
#define TG_MAC_SEND_REF                       0xf8    /* 248 */
#define TG_MAC_SEND_NEXT                      0xfc    /* 252 */
#define TG_READ_HI_PROD                      0x100    /* 256 */
#define TG_READ_HI_CONS                      0x104    /* 260 */
#define TG_READ_HI_REF			     0x108    /* 264 */
#define TG_READ_HI_NEXT                      0x10c    /* 268 */
#define TG_ASSIST_STATE                      0x11c    /* 272 */
#define TG_WRITE_HI_PROD                     0x120    /* 288 */
#define TG_WRITE_HI_CONS                     0x124    /* 292 */
#define TG_WRITE_HI_REF                      0x128    /* 296 */
#define TG_WRITE_HI_NEXT                     0x12c    /* 300 */
#define TG_MAC_RX_STATE			     0x220    /* 544 */

#define TG_EVENT_MAILBOX                0x00400000
#define TG_MAC_TX_W1_NO_CRC             0x80000000
#define TG_MAC_TX_W1_NO_CRC_SHIFT               31
#define TG_DMA_STATE_UPDATE_TX_BUF_PROD 0x00020000
#define TG_DMA_STATE_BYTE_BUCKET        0x00040000
#define TG_FW_EVENT_DMA_RD_ASST_HI      0x00008000

#define TG_MAC_RX_STATE_BLOCKING	0x00020000
#define TG_MAC_TX_W0_ADDR_MASK		0x001fffff
#define TG_MAC_TX_W0_NO_CRC		0x80000000
#define TG_MAC_TX_W0_NO_TAG		0x00000000
#define TG_MAC_TX_W0_REM_TAG		0x20000000
#define TG_MAC_TX_W0_ADD_TAG		0x40000000
#define TG_MAC_TX_W0_MAP_TAG		0x60000000
#define TG_MAC_TX_W1_LEN_MASK		0x0000ffff
#define TG_MAC_TX_W1_TAG_SHIFT		        16
#define TG_MAC_RX_W1_ODD_NIBBLES	0x00100000
#define TG_MAC_RX_W1_TRUNC_NO_RESOURCES	0x00800000
	
#define TG_DATA_END			0x00200000
#define TG_DATA_SIZE			(TG_RX_BUF_SIZE+TG_TX_BUF_SIZE+0x10000)
#define TG_DATA_START	                (TG_DATA_END-TG_DATA_SIZE)
#define TG_RX_BUF_START			(TG_DATA_END-TG_RX_BUF_SIZE)
#define TG_RX_BUF_END_U			(TG_DATA_END-0x10000)
#define TG_RX_BUF_END_L			0xfff8
#define TG_TX_BUF_START			(TG_DATA_END-(TG_RX_BUF_SIZE+TG_TX_BUF_SIZE))
#define TG_TX_BUF_END_U			((TG_RX_BUF_START-1)/0x10000*0x10000)
#define TG_TX_BUF_END_L			(TG_RX_BUF_START-1-TG_TX_BUF_END_U)
	

#define TG_DMA_STATE_THRESH             0x00000190
#define TG_DMA_RD_STATE_FIFO		0x0006
	
#define TG_MBOX0_HIGH                   0x100	      /* 256 */
#define TG_MBOX0_LOW                    0x104	      /* 260 */
/* End stuff from tg.h */

