#
# COPYRIGHT NOTICE
# Copyright (c) Alteon Networks, Inc. 1996
# All rights reserved
#
# HISTORY
# $Log: disp.s,v $
# Revision 1.1.2.8  1998/09/30  18:49:49  shuang
# 	change for new 12.3 API
# 	[1998/09/30  18:39:35  shuang]
#
# Revision 1.1.2.7  1998/08/03  16:14:24  hayes
# 	complete firmware update for NT
# 	[1998/08/03  16:11:16  hayes]
# 
# 	checkin so merge w/ fc can happen
# 	[1998/07/29  23:15:24  hayes]
# 
# 	host based send ring now works off RCB flag
# 	[1998/07/29  18:30:55  hayes]
# 
# 	host based send ring works
# 	[1998/07/28  03:57:15  hayes]
# 
# Revision 1.1.2.6  1998/04/11  05:15:03  shuang
# 	move fast timer to cpu B, add receive coalesed ticks
# 	[1998/04/11  04:57:49  shuang]
# 
# Revision 1.1.2.5  1998/04/01  22:21:21  hayes
# 	checkpoint- dma completion avoidance works
# 	[1998/03/30  07:00:25  hayes]
# 
# 	intermediate checkin
# 	[1998/03/29  00:18:04  hayes]
# 
# Revision 1.1.2.4  1998/03/26  01:34:22  shuang
# 	cleanup
# 	[1998/03/26  01:24:53  shuang]
# 
# Revision 1.1.2.3  1998/02/19  01:29:48  suresh
# 	Keep second CPU from interacting badly with dispatcher when dispatcher is idle
# 	[1998/02/19  01:16:24  suresh]
# 
# Revision 1.1.2.2  1998/01/29  18:40:19  ted
# 	Add missing register set for scream_handler
# 	[1998/01/29  18:27:48  ted]
# 
# Revision 1.1.2.1  1998/01/14  23:25:40  ted
# 	rearrange directories
# 	[1998/01/14  23:17:39  ted]
# 
# Revision 1.1.2.3  1998/01/14  19:56:02  skapur
# 	Merged with changes from 1.1.2.2
# 	[1998/01/14  19:55:34  skapur]
# 
# 	Checksum off-load support for Tigon2. This is an intermediate checkin; more work needs to be done
# 	[1998/01/14  19:26:15  skapur]
# 
# Revision 1.1.2.2  1997/12/29  19:02:04  hayes
# 	remove reference to h_send_replicate()
# 	[1997/12/29  18:58:18  hayes]
# 
# Revision 1.1.2.1  1997/11/19  19:23:04  ted
# 	Support Tigon and Tigon2 in the same driver
# 	[1997/11/19  19:18:59  ted]
# 
# Revision 1.7.4.13  1997/11/14  19:16:18  hayes
# 	first checkin after mongo merge...
# 	[1997/11/14  19:11:19  hayes]
# 
# 	checkin after stats restructuring
# 	[1997/11/12  19:01:09  hayes]
# 
# 	intermediate checkin
# 	[1997/11/12  01:30:34  hayes]
# 
# Revision 1.7.4.12  1997/11/11  19:05:54  hayes
# 	restructuring for scratchpad use
# 	[1997/11/11  19:04:14  hayes]
# 
# Revision 1.7.4.11  1997/10/03  00:05:49  hayes
# 	fix backtick in comments so it work with preprocessor
# 	[1997/10/03  00:05:26  hayes]
# 
# 	completed link code restructuring
# 	[1997/08/29  22:09:14  hayes]
# 
# Revision 1.7.4.10  1997/08/29  22:12:06  hayes
# 	completed link code restructuring
# 
# Revision 1.7.4.9  1997/08/23  17:40:04  skapur
# 	Solaris jumbogram support
# 	[1997/08/23  17:37:50  skapur]
# 
# Revision 1.7.4.8  1997/04/25  18:48:44  ted
# 	Take DMA read completion events again
# 	[1997/04/25  18:32:46  ted]
# 
# Revision 1.7.4.7  1997/03/28  02:46:54  skapur
# 	Removed bunch of handlers which are not needed any more
# 	[1997/03/28  01:54:21  skapur]
# 
# Revision 1.7.4.6  1997/03/17  08:47:38  skapur
# 	integration changes...
# 	[1997/03/16  03:01:40  skapur]
# 
# Revision 1.7.4.5  1997/02/28  20:02:21  ted
# 	Remove DMA corruption workaround, fix 3 subtle bugs
# 	[1997/02/28  20:01:35  ted]
# 
# Revision 1.7.4.4  1997/02/23  00:23:29  ted
# 	Commented out h_mac_tx_comp and added h_dma_corruption_hack
# 	in place of sw14 for HW workaround
# 	[1997/02/23  00:10:43  ted]
# 
# Revision 1.7.4.3  1997/02/17  05:05:48  ted
# 	Add back in tg_tx_comp hardware buf workaround code
# 	[1997/02/17  05:05:12  ted]
# 
# Revision 1.7.4.2  1997/02/17  00:44:15  skapur
# 	# If defed out the code for hack for sw tx_comp event
# 	[1997/02/17  00:43:44  skapur]
# 
# Revision 1.7.4.1  1997/02/11  02:50:13  ted
# 	Add SW0 event handler to h_mac_rx_comp to work around
# 	rx_comp bug in Rev A tigon.
# 	[1997/02/11  02:41:45  ted]
# 
# Revision 1.7.2.2  1996/11/05  21:54:15  hayes
# 	Final pre-ODE merge
# 	[1996/11/05  21:51:23  hayes]
# 
# Revision 1.7.2.1  1996/11/01  18:24:48  ted
# 	Add Copyright notice and history
# 	[1996/10/30  00:45:29  ted]
# 
# $EndLog$
#
#
# COPYRIGHT (c) Essential Communication Corp. 1995
# $Source: /projects/rcs/sw/ge/./nic/fw2/common/disp.s,v $
# $Revision: 1.1.2.8 $ $Locker:  $
# $Date: 1998/09/30 18:49:49 $ $Author: shuang $ $State: Exp $
#
	.file	1 "disp.s"
	.globl  ev_handler
	.align	8
	.set	noreorder	
ev_handler:
	jr $16			        # nothing set, just redo pri
	nop
	j	scream_handler	        # SW 0
	lui $10,1
	j	scream_handler	        # SW 1
	lui $10,2
	j	scream_handler          # MAC transmit completion
	nop
	j	h_send_data_ready	# SW 2
	nop
	j	h_send_bd_ready		# SW 3
	nop
	j	scream_handler	        # MAC receive start
	lui $10,4
	j	h_mac_rx_comp_nohost	# MAC Receive completed
	nop
	j	h_update_led2	        # SW 4
	nop
	j	h_recv_jumbo_bd_ready	# SW 5
	nop
	j	h_recv_bd_ready	        # SW 6
	nop
	j	scream_handler          # set rem CPU attn
	lui $10,6
	j	h_recv_mini_bd_ready    # SW 7
	lui $10,7
	j	scream_handler          # DMA write assist low complete   
	lui $10,8
	j	scream_handler          # DMA read assist low complete   
	lui $10,9
	j	h_dma_wr_assist         # DMA write assist high complete   
	nop
	j	h_dma_rd_assist         # DMA read assist high complete   
	nop
	j	scream_handler	        # SW 8
	lui $10,11
	j	scream_handler	        # Write DMA complete successfully
	lui $10,12
	j	scream_handler	        # Read DMA completed successfully
	lui $10,13
	j	h_dma_wr_attn	        # Write DMA stopped due to error
	nop
	j	h_dma_rd_attn	        # Read DMA stopped due to error
	nop
	j	scream_handler	        # SW 9
	lui $10,14
	j	mh_command	        # Mailbox event asserted
	nop
	j	h_do_update_tx_cons     # SW 10
	nop
	j	h_do_update_rx_prod     # SW 11
	nop
	j	h_mac_rx_attn           # MAC Receiver needs attention
	nop
	j	h_mac_tx_attn           # MAC Transmit needs attention
	nop
	j	scream_handler	        # rem CPU attn
	nop
	j	h_timer			# Timer reference reached
	nop
	j	scream_handler	        # SW 12
	nop
        j       scream_handler          # external serial data
	lui $10,19
	j	scream_handler	        # SW 13
	lui $10,20
