# COPYRIGHT NOTICE
# Copyright (c) Alteon WebSystems, Inc. 1999
# All rights reserved
#
# HISTORY
# $Log: dmaasm.s $
# Revision nic_api_12_4_latest_shuang/3 1999/11/10 17:51:41 shuang
# 	add USE_ASM compile flag
# 
# $EndLog$
#
# $Source$
# $Revision$ $Locker$
# $Date$ $Author$ $State$
#

#if USE_ASM
#define _IN_ASM_

#include "asm.h"
#include "nic.h"
#include "nic_api.h"
				
	.file	1 "../../../../../src/nic/fw2/common/dmaasm.s"

	.globl	q_dma_to_host_cksum
	.globl	q_dma_to_host_cksum_end
	.globl	q_dma_to_nic_cksum
	.globl	q_dma_to_nic_cksum_end

	.ent	q_dma_to_host_cksum
	
q_dma_to_host_cksum:	
	.frame	$sp,0,REG_LINK
	.set	noreorder

/*  local registers */
#define scratch  $2
#define scratch2 $3	
#define dd_prod  $8
#define ndd_prod $9

/* local parm values */	
#define parm5		16($sp)
#define parm6		20($sp)
#define parm7		24($sp)
	
	lw	dd_prod,TG_WRITE_HI_PROD(REG_TRP)
	addu	scratch,REG_TDP,tdp_wr_dma_ring_end
	lw	scratch2,TG_WRITE_HI_REF(REG_TRP)
	bne	dd_prod,scratch,wr_check_full
	addiu	ndd_prod,dd_prod,sizeof_dma_descr

	addu	ndd_prod,REG_TDP,tdp_wr_dma_ring
	
wr_check_full:	
	beq	ndd_prod,scratch2,wr_ring_full
	lw	scratch,parm5	                  # type
	sw	parm1,dd_host_addr_hi(dd_prod)
	sw	parm2,dd_host_addr_lo(dd_prod)
	sw	parm3,dd_nic_addr(dd_prod)
	sh	parm4,dd_length(dd_prod)
	lw	scratch2,parm6			  # index
	sw	scratch,dd_type(dd_prod)
	lw	scratch,parm7			  # state
	sw	scratch2,dd_index(dd_prod)
	addiu	scratch2,dd_prod,dd_cksum
	sw	scratch,dd_state(dd_prod)
	sw	scratch2,dd_cksum_ptr(dd_prod)
	sw	ndd_prod,TG_WRITE_HI_PROD(REG_TRP)
	lw	scratch2,nicfp_wr_dma_free_cnt(REG_NICFP)
	li	RETURN_CODE,1
	addiu	scratch2,scratch2,-1
	jr	REG_LINK
	sw	scratch2,nicfp_wr_dma_free_cnt(REG_NICFP)

wr_ring_full:	
	lw	scratch2,stats_nicDmaWriteRingFull(REG_NICFP)
	move	RETURN_CODE,REG_ZERO
	addiu	scratch2,scratch2,1
	jr	REG_LINK
	sw	scratch2,stats_nicDmaWriteRingFull(REG_NICFP)

/*  local registers for peek_mac_rx() */
#undef scratch
#undef scratch2
#undef dd_prod
#undef ndd_prod

/* local parm values */	
#undef parm5
#undef parm6
#undef parm7

		.set	reorder
	.end	q_dma_to_host_cksum

	.ent	q_dma_to_host_cksum_end
	.frame	$sp,0,REG_LINK
	.set	noreorder
q_dma_to_host_cksum_end:	
	jr	REG_LINK
	nop
	.set	reorder
	.end	q_dma_to_host_cksum_end

	.ent	q_dma_to_nic_cksum
	
q_dma_to_nic_cksum:	
	.frame	$sp,0,REG_LINK
	.set	noreorder

/*  local registers */
#define scratch  $2
#define scratch2 $3	
#define dd_prod  $8
#define ndd_prod $9

/* local parm values */	
#define parm5		16($sp)
#define parm6		20($sp)
#define parm7		24($sp)
	
	lw	dd_prod,TG_READ_HI_PROD(REG_TRP)
	addu	scratch,REG_TDP,tdp_rd_dma_ring_end
	lw	scratch2,TG_READ_HI_REF(REG_TRP)
	bne	dd_prod,scratch,rd_check_full
	addiu	ndd_prod,dd_prod,sizeof_dma_descr

	addu	ndd_prod,REG_TDP,tdp_rd_dma_ring
	
rd_check_full:	
	beq	ndd_prod,scratch2,rd_ring_full
	lw	scratch,parm5	                  # type
	sw	parm1,dd_host_addr_hi(dd_prod)
	sw	parm2,dd_host_addr_lo(dd_prod)
	sw	parm3,dd_nic_addr(dd_prod)
	sh	parm4,dd_length(dd_prod)
	lw	scratch2,parm6			  # index
	sw	scratch,dd_type(dd_prod)
	lw	scratch,parm7			  # state
	sw	scratch2,dd_index(dd_prod)
	addiu	scratch2,dd_prod,dd_cksum
	sw	scratch,dd_state(dd_prod)
	sw	scratch2,dd_cksum_ptr(dd_prod)
	sw	ndd_prod,TG_READ_HI_PROD(REG_TRP)
	jr	REG_LINK
	li	RETURN_CODE,1

rd_ring_full:	
	lw	scratch2,stats_nicDmaReadRingFull(REG_NICFP)
	move	RETURN_CODE,REG_ZERO
	addiu	scratch2,scratch2,1
	jr	REG_LINK
	sw	scratch2,stats_nicDmaReadRingFull(REG_NICFP)

/*  local registers for peek_mac_rx() */
#undef scratch
#undef scratch2
#undef dd_prod
#undef ndd_prod

/* local parm values */	
#undef parm5
#undef parm6
#undef parm7

		.set	reorder
	.end	q_dma_to_nic_cksum

	.ent	q_dma_to_nic_cksum_end
	.frame	$sp,0,REG_LINK
	.set	noreorder
q_dma_to_nic_cksum_end:	
	jr	REG_LINK
	nop
	.set	reorder
	.end	q_dma_to_nic_cksum_end

#endif /* USE_ASM */
