/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1996
 * All rights reserved
 */
/*
 * HISTORY
 * $Log: proto.h $
 * Revision nic_api_12_4_latest_shuang/10 2000/02/29 18:18:07 shuang
 * 	fix: BDs related stats should not be refreshed by refresh cmd
 * 
 * Revision nic_api_12_4_latest_shuang/8 2000/02/12 18:50:05 shuang
 * 	fix incorrect stats nicRecvBDs and nicJumboRecvBDs.
 * 	honor TG_CMD_CODE_STACK_UP and TG_CMD_CODE_STACK_DOWN commands.
 * 
 * Revision nic_api_12_4_latest_shuang/6 1999/12/11 03:11:22 shuang
 * 	fix: need to refresh hw mac stats on the REFRESH command.
 * 
 * Revision nic_api_12_4_latest_shuang/4 1999/12/09 19:51:56 shuang
 * 	work around Tg2 MAC6 bug only if get rx buf full attention.
 * 
 * Revision nic_api_12_4_latest_shuang/2 1999/11/13 22:03:57 shuang
 * 	fix ext add/del mcast addr command
 * 
 * Revision copper_fhwang/2 1999/10/12 19:39:27 fhwang
 * 	add h_update_led4 prototype
 * 
 * Revision sgi_api_12_3_latest_shuang/2 1999/07/14 18:58:50 shuang
 * 	work around MAC6 Tigon2 bug, fix rx buffer full cleanup
 * 
 * Revision 1.1.2.22  1998/12/08  02:36:39  shuang
 * 	Clean up debug tracing. Use sw dma. Fix dma avoidance.
 * 	[1998/12/08  02:28:15  shuang]
 *
 * Revision 1.1.2.21  1998/10/14  01:14:30  shuang
 * 	support tx buffer ratio
 * 	[1998/10/14  01:07:25  shuang]
 * 
 * Revision 1.1.2.20  1998/09/30  18:50:11  shuang
 * 	change for new 12.3 API
 * 	[1998/09/30  18:40:24  shuang]
 * 
 * Revision 1.1.2.19  1998/08/27  23:22:54  shuang
 * 	add new mcast and mbox cmds, intr masks, obsolete recv ret cons idx
 * 	[1998/08/27  23:20:44  shuang]
 * 
 * Revision 1.1.2.18  1998/08/03  16:14:30  hayes
 * 	complete firmware update for NT
 * 	[1998/08/03  16:11:21  hayes]
 * 
 * 	checkin so merge w/ fc can happen
 * 	[1998/07/29  23:15:31  hayes]
 * 
 * 	host based send ring now works off RCB flag
 * 	[1998/07/29  18:31:02  hayes]
 * 
 * 	host based send ring works
 * 	[1998/07/28  03:57:23  hayes]
 * 
 * Revision 1.1.2.17  1998/07/29  01:45:43  shuang
 * 	work around hang problem of dma channal between SBUS and X-Chip
 * 	[1998/07/29  01:44:40  shuang]
 * 
 * Revision 1.1.2.16  1998/06/23  01:29:41  shuang
 * 	added dynamic nic mem support.
 * 	[1998/06/23  01:21:51  shuang]
 * 
 * Revision 1.1.2.15  1998/04/27  23:49:58  shuang
 * 	added proto null_handler_end for assisting relocation
 * 	[1998/04/27  23:49:12  shuang]
 * 
 * Revision 1.1.2.14  1998/04/27  22:13:52  shuang
 * 	cleanup
 * 	[1998/04/27  17:45:03  shuang]
 * 
 * Revision 1.1.2.13  1998/04/25  01:42:26  shuang
 * 	removed unused proto types for udpcksum, tcpcksum
 * 	[1998/04/25  01:07:35  shuang]
 * 
 * Revision 1.1.2.12  1998/04/24  00:00:41  hayes
 * 	added const to rcsid definitions to eliminate compiler warnings
 * 	[1998/04/23  23:58:55  hayes]
 * 
 * Revision 1.1.2.11  1998/04/11  05:15:16  shuang
 * 	move fast timer to cpu B, add receive coalesed ticks
 * 	[1998/04/11  04:58:37  shuang]
 * 
 * Revision 1.1.2.10  1998/04/01  22:21:26  hayes
 * 	checkpoint
 * 	[1998/03/31  19:56:57  hayes]
 * 
 * 	checkpoint- dma completion avoidance works
 * 	[1998/03/30  07:00:32  hayes]
 * 
 * 	intermediate checkin
 * 	[1998/03/29  00:18:08  hayes]
 * 
 * Revision 1.1.2.9  1998/04/01  07:32:24  shuang
 * 	add enable scratch pad control - code, vars, stack...
 * 	[1998/04/01  07:24:02  shuang]
 * 
 * Revision 1.1.2.8  1998/03/26  01:34:29  shuang
 * 	cleanup
 * 	[1998/03/26  01:25:27  shuang]
 * 
 * Revision 1.1.2.7  1998/03/04  04:37:10  hayes
 * 	     make scratch_pad_enable external
 * 	     [1998/03/04  04:36:57  hayes]
 * 
 * Revision 1.1.2.6  1998/02/24  17:41:50  shuang
 * 	     Add multicast function protos
 * 	     [1998/02/24  17:35:18  shuang]
 * 
 * Revision 1.1.2.5  1998/02/19  01:29:59  suresh
 * 	     CPU b protos and removal of unnecessary q_dma_to_xxx routines
 * 	     [1998/02/19  01:23:39  suresh]
 * 
 * 	     intermediate checksum offload state
 * 	     [1998/02/15  01:27:38  suresh]
 * 
 * Revision 1.1.2.4  1998/02/11  19:11:23  ted
 * 	     protos for checksum offload routines, removal of 10s of old prototypes
 * 	     [1998/02/11  18:47:19  ted]
 * 
 * Revision 1.1.2.3  1998/02/09  17:18:06  hayes
 * 	     convert Q_DMA_XXX macros to functions
 * 	     [1998/02/09  17:16:57  hayes]
 * 
 * Revision 1.1.2.2  1998/01/20  04:39:22  hayes
 * 	     add tigon Rev6 support
 * 	     [1998/01/20  04:37:59  hayes]
 * 
 * Revision 1.1.2.1  1998/01/14  23:25:57  ted
 * 	     rearrange directories
 * 	     [1998/01/14  23:17:52  ted]
 * 
 * Revision 1.1.2.3  1998/01/14  19:56:04  skapur
 * 	     Merged with changes from 1.1.2.2
 * 	     [1998/01/14  19:55:51  skapur]
 * 
 * 	     Checksum off-load support for Tigon2. This is an intermediate checkin; more work needs to be done
 * 	     [1998/01/14  19:26:44  skapur]
 * 
 * Revision 1.1.2.2  1997/12/29  19:02:09  hayes
 * 	     remove q_bd_to_host() and  h_send_replicate(0, obsolete
 * 	     [1997/12/29  19:00:26  hayes]
 * 
 * Revision 1.1.2.1  1997/11/19  19:23:18  ted
 * 	     Support Tigon and Tigon2 in the same driver
 * 	     [1997/11/19  19:19:47  ted]
 * 
 * Revision 1.9.7.7  1997/11/14  19:16:35  hayes
 * 	     first checkin after mongo merge...
 * 	     [1997/11/14  19:11:40  hayes]
 * 
 * 	     checkin after stats restructuring
 * 	     [1997/11/12  19:01:34  hayes]
 * 
 * 	     intermediate checkin
 * 	     [1997/11/12  01:30:43  hayes]
 * 
 * Revision 1.9.7.6  1997/11/11  19:06:00  hayes
 * 	     restructuring for scratchpad use
 * 	     [1997/11/11  19:04:26  hayes]
 * 
 * 	     completed link code restructuring
 * 	     [1997/08/29  22:09:29  hayes]
 * 
 * Revision 1.9.7.5  1997/08/29  22:12:26  hayes
 * 	     completed link code restructuring
 * 
 * Revision 1.9.7.4  1997/08/23  17:40:08  skapur
 * 	     Solaris jumbogram support
 * 	     [1997/08/23  17:38:02  skapur]
 * 
 * Revision 1.9.7.3  1997/03/21  04:15:38  skapur
 * 	     Performance enhancement for Recv and Send; lots changes; almost complete overhaul of the entire firmware
 * 	     [1997/03/21  04:08:21  skapur]
 * 
 * Revision 1.9.7.2  1997/02/28  20:02:26  ted
 * 	     Remove DMA corruption workaround, fix 3 subtle bugs
 * 	     [1997/02/28  20:01:46  ted]
 * 
 * Revision 1.9.7.1  1997/02/23  00:23:37  ted
 * 	     Added proto for h_dma_corruption_hack and commented out bunch of mac routines protos; last 4 routines in this file
 * 	     [1997/02/23  00:13:36  ted]
 * 
 * Revision 1.9.2.4  1996/11/29  17:43:22  hayes
 * 	     Changes init_mac() to init_mac1() and init_mac2().
 * 	     [1996/11/29  17:40:24  hayes]
 * 
 * Revision 1.9.2.3  1996/11/15  04:24:16  hayes
 * 	     convert to new header file structure.
 * 	     [1996/11/15  04:12:19  hayes]
 * 
 * Revision 1.9.2.2  1996/11/05  21:54:27  hayes
 * 	     Final pre-ODE merge
 * 	     [1996/11/05  21:52:09  hayes]
 * 
 * Revision 1.9.2.1  1996/11/01  18:25:04  ted
 * 	     change rr_ to tg_, fix compiler warnings, add copyright notices
 * 	     [1996/10/29  22:06:31  ted]
 * 
 * $EndLog$
 */
/*
 * FILE proto.h
 *
 * COPYRIGHT (c) Essential Communication Corp. 1995
 * $Source: /projects/rcs/sw/ge/./nic/fw2/common/proto.h,v $
 * $Revision: 1.1.2.22 $ $Locker:  $
 * $Date: 1998/12/08 02:36:39 $ $Author: shuang $ $State: Exp $
 */

#ifndef _PROTO_H_
#define _PROTO_H_

/*
 * prototypes for all the routines
 */

extern U32 deq_mac_rx_len;
extern tg_shmem_t *gtsp;
extern U32 ev_handler[66];
extern U32 *ev_handler_stub;
extern U32 peek_mac_rx_len;
extern U32 scratch_pad_enable_code;
extern U32 scratch_pad_enable_stack;
extern U32 scratch_pad_enable_vars;
extern U32 stack_start;
extern U32 stack_start_b;

extern U32 h_dma_rd_assist_stub;
extern U32 h_do_update_rx_prod_stub;
extern U32 h_do_update_tx_cons_stub;
extern U32 h_mac_rx_attn_stub;
extern U32 h_mac_rx_comp_stub;
extern U32 h_recv_bd_ready_stub;
extern U32 h_send_bd_ready_stub;
extern U32 h_recv_jumbo_bd_ready_stub;
extern U32 h_recv_mini_bd_ready_stub;
extern U32 h_send_data_ready_stub;
extern U32 h_timer_stub;
extern U32 h_update_led_stub;
extern U32 mh_command_stub;
extern U32 null_handler_stub;

extern void _disp(void);
extern void add_mcast(tg_macaddr_t *);
extern void bcopy(U32 *, U32 *, U32);
extern void bzero(U32 *, U32);
extern U16  cksum16(U16 *, U32, U32, U32);
extern void cksum16_end(void);
extern void clear_stats(void);
extern U16  crc_cksum(U8 *);
extern void del_mcast(tg_macaddr_t *);
extern void deq_mac_rx(void);
extern void deq_mac_rx_end(void);
extern void (*deq_mac_rx_stub)(void);
extern void deq_mac_rx_v5(void);
extern void deq_mac_rx_v5_end(void);
extern U32  do_mailbox_slow(struct tg_command, U32);
extern void fix_xchip_hang_on_sbus(void);
extern U32  gen_crc(U8 *addr, U32 len);
extern U32  get_tx_buf_size(U32);
extern void h_dma_rd_assist(void);
extern void h_dma_rd_assist_cksum(void);
extern void h_dma_rd_assist_cksum_end(void);
extern void h_dma_rd_assist_end(void);
extern void h_dma_rd_attn(void);
extern void h_dma_wr_assist(void);
extern void h_dma_wr_assist_cksum(void);
extern void h_dma_wr_assist_cksum_end(void);
extern void h_dma_wr_assist_end(void);
extern void (*h_dma_wr_assist_stub)(void);
extern void h_dma_wr_attn(void);
extern void h_do_update_rx_prod(void);
extern void h_do_update_rx_prod_end(void);
extern void h_do_update_tx_cons(void);
extern void h_do_update_tx_cons_end(void);
extern void h_mac_rx_attn(void);
extern void h_mac_rx_attn_end(void);
extern void h_mac_rx_comp(void);
extern void h_mac_rx_comp_cksum(void);
extern void h_mac_rx_comp_cksum_end(void);
extern void h_mac_rx_comp_end(void);
extern void h_mac_rx_comp_nohost(void);
extern void h_mac_rx_start(void);
extern void h_mac_tx_attn(void);
extern void h_mailbox(void);
extern void h_recv_bd_ready(void);
extern void h_recv_bd_ready_end(void);
extern void h_recv_jumbo_bd_ready(void);
extern void h_recv_jumbo_bd_ready_end(void);
extern void h_recv_mini_bd_ready(void);
extern void h_recv_mini_bd_ready_end(void);
extern void h_send_bd_ready(void);
extern void h_send_bd_ready_end(void);
extern void h_send_data_ready(void);
extern void h_send_data_ready_cksum(void);
extern void h_send_data_ready_cksum_end(void);
extern void h_send_data_ready_end(void);
extern void h_timer(void);
extern void h_timer_end(void);
extern void h_update_led2(void);
extern void h_update_led2_end(void);
extern void h_update_led4(void);
extern void h_update_led4_end(void);
extern void h_update_led6(void);
extern void h_update_led6_end(void);
extern void init_dma_assist(void);
extern void init_mac_buf(void);
extern void init_mac2(void);
extern void init_mailbox(void);
extern void init_timer(void);
extern void init_timer_b(void);
extern void init_trace(void);
extern void ltrace(U32 *, U32, U32, U32, U32, U32, U32 *);
extern void mcast_init(void);
extern bool mcast_rx_filter(U8 *addr);
extern void mcast_rx_filter_end(void);
extern void memcpy(U32 *dst, U32 *src, U32 len);
extern void memset_w(U32 *, U32, U32);
extern void mh_command(void);
extern void mh_command_end(void);
extern void null_handler(void);
extern void null_handler_end(void);
extern void null_profile_handler(void);
extern void null_profile_handler_end(void);
extern tgMacDescr_t *peek_mac_rx(void);
extern tgMacDescr_t *peek_mac_rx_wa(void);
extern void peek_mac_rx_end(void);
extern void peek_mac_rx_wa_end(void);
extern tgMacDescr_t *(*peek_mac_rx_stub)(void);
extern void probe_adj_stack(void);
extern U32  probe_mem_size(void);
extern void propagate_u64_stats(void);
extern U32  q_dma_to_host_cksum(tg_hostaddr_t, U32, U32, U32, U32, U32);
extern void q_dma_to_host_cksum_end(void);
extern U32  q_dma_to_host(tg_hostaddr_t, U32, U32, U32, U32, U32);
extern void q_dma_to_host_end(void);
extern U32  q_dma_to_nic_cksum(tg_hostaddr_t, U32, U32, U32, U32, U32);
extern void q_dma_to_nic_cksum_end(void);
extern U32  q_dma_to_nic(tg_hostaddr_t, U32, U32, U32, U32, U32);
extern void q_dma_to_nic_end(void);
extern void refresh_stats_slow(void);
extern void rx_ip_sanity(U32, U32);
extern void scream_handler(void);
extern void strace(U32 *, U32, U32, U32, U32, U32, U32 *, U32, U32);
extern U16  tcp_udp_cksum(U32, U32, U32);
extern void trace(U32 *, U32, U32, U32, U32, U32);
extern void update_stats(void);
extern void wait_us(U32);


/* CPU B protos */

extern tgDmaDescr_t *preload_rd_descr_p;
extern tgDmaDescr_t *preload_wr_descr_p;
extern tgDmaDescr_t preload_rd_descr;   /* locate in scratchpad */
extern tgDmaDescr_t preload_wr_descr;   /* locate in scratchpad */

extern void (*sw_dma_assist_stub)(void);
extern void _start_b(void);
extern void h_hf_timer(void);
extern void h_hf_timer_end(void);
extern void sw_dma_assist(void);
extern void sw_dma_assist_end(void);
extern void sw_dma_assist_plus_timer(void);
extern void sw_dma_assist_plus_timer_end(void);


#endif /* _PROTO_H_ */
