# COPYRIGHT NOTICE
# Copyright (c) Alteon WebSystems, Inc. 1999
# All rights reserved
#
# HISTORY
# $Log: recvasm.s $
# Revision nic_api_12_4_latest_shuang/5 1999/12/09 19:51:57 shuang
# 	work around Tg2 MAC6 bug only if get rx buf full attention.
# 
# Revision nic_api_12_4_latest_shuang/3 1999/11/10 17:43:33 shuang
# 	restore deq_mac_rx asm; undo h_recv_bd_ready asm
# 
# $EndLog$
#
# $Source$
# $Revision$ $Locker$
# $Date$ $Author$ $State$
#

#if USE_ASM
#define _IN_ASM_
		
#include "asm.h"
#include "nic.h"
#include "nic_api.h"
#include "dma.h"
				
	.file	1 "../../../../../src/nic/fw2/common/recvasm.s"

	.globl	deq_mac_rx
	.globl	deq_mac_rx_end
#if 0	
	.globl	peek_mac_rx_wa
	.globl	peek_mac_rx_wa_end
	.globl	h_recv_bd_ready
	.globl	h_recv_bd_ready_end
	.globl	h_dma_wr_assist
	.globl	h_dma_wr_assist_end
	.globl	h_dma_wr_assist_cksum
	.globl	h_dma_wr_assist_cksum_end
#endif /* 0 */	


	.ent	peek_mac_rx_wa

/*  local registers for peek_mac_rx_wa() */
#define scratch		$2
#define scratch2	$3	
#define bp		$4
#define mdp_prod	$5
#define mdp_prod_sv	$6
#define mdp_cons	$7
#define mdp_cons_next	$8
#define space		$9
#define bp_next         $10
#define scratch3        $11
				
peek_mac_rx_wa:
	.frame	$sp,0,REG_LINK
	.set	noreorder

	/* bp = trp->local_mem_conf.rx_buf_producer; */
	lw	bp,TG_RECV_BUF_PROD(REG_TRP)
        /* mdp_prod_sv = trp->local_mem_conf.mac_rx_descr_producer; */
	lw	mdp_prod_sv,TG_MAC_RECV_PROD(REG_TRP)
        /* mdp_cons = trp->local_mem_conf.mac_rx_descr_consumer; */
	lw	mdp_cons,TG_MAC_RECV_CONS(REG_TRP)

	/* (U32)mdp_prod = ROUNDDN((U32)mdp_prod_sv, 8); */
	li	scratch,-8
	and	mdp_prod,mdp_prod_sv,scratch

	/* if (mdp_cons == mdp_prod) { */
	beq	mdp_cons,mdp_prod,return_0
	addu	scratch,REG_TDP,tdp_rx_mac_ring_end
	
        /* mdp_cons_next = get_next_mac_rx_descr(mdp_cons); */
	bne	mdp_cons,scratch,peek_nowrap
	addu	mdp_cons_next,mdp_cons,8

	addu	mdp_cons_next,REG_TDP,tdp_rx_mac_ring

peek_nowrap:
        /* if (mdp_cons_next == mdp_prod) { */
	bnel	mdp_cons_next,mdp_prod,notlast
	lw	bp_next,0(mdp_cons_next)

	/* if ((U32)mdp_prod_sv & 4) */
	/*     return ((tgMacDescr_t *)0); */
	/* else */
	/*     bp_next = bp; */
	andi	scratch,mdp_prod_sv,4
	bne	scratch,REG_ZERO,return_0
	move	bp_next,bp

notlast:	
	/* space = bp_next - mdp_cons->w0; */
	lw	space,0(mdp_cons)
        /* if (space > NIC_RX_BUF_SIZE) */
	lw	scratch,nicfp_rx_buf_size(REG_NICFP)
	subu	space,bp_next,space
	sltu	scratch2,scratch,space
	lhu	scratch3,6(mdp_cons)          /* w1 & TG_MAC_RX_W1_LEN_MASK */
	beq	scratch2,REG_ZERO,peek_nowrap2
	addu	scratch2,scratch3,80	      /* + 80 */

	/*   space += NIC_RX_BUF_SIZE; */
	addu	space,scratch,space

peek_nowrap2:
        /* if (space >= ((mdp_cons->w1 & TG_MAC_RX_W1_LEN_MASK) + 80)) { */
	sltu	scratch2,space,scratch2
	beql	scratch,REG_ZERO,bad_frame
	lw	scratch,stats_ifInDiscards(REG_NICFP)
	
        /* return (mdp_cons); */
	j	REG_LINK
	move	RETURN_CODE,mdp_cons

bad_frame:	
	/* trp->local_mem_conf.mac_rx_descr_ref = mdp_cons_next; */
	sw	mdp_cons_next,TG_MAC_RECV_REF(REG_TRP)
	/* nicfp->stats.ifInDiscards++; */
	addu	scratch,scratch,1
	sw	scratch,stats_ifInDiscards(REG_NICFP)
	/* trp->local_mem_conf.mac_rx_descr_consumer = mdp_cons_next; */
	sw	mdp_cons_next,TG_MAC_RECV_CONS(REG_TRP)

return_0:	
	j	REG_LINK
	move	RETURN_CODE,REG_ZERO	
			
/* remove local regs */
#undef scratch
#undef scratch2
#undef bp
#undef mdp_prod
#undef mdp_prod_sv
#undef mdp_cons
#undef mdp_cons_next
#undef space
#undef bp_next
#undef scratch3

	.set	reorder
	.end	peek_mac_rx_wa

	.ent	peek_mac_rx_wa_end
	.frame	$sp,0,REG_LINK
	.set	noreorder
peek_mac_rx_wa_end:
	jr	REG_LINK
	nop
	.set	reorder
	.end	peek_mac_rx_wa_end
	
	.ent	deq_mac_rx

/*  local registers for deq_mac_rx() */
#define scratch  $2
#define mdp_cons $3
		
deq_mac_rx:
	.frame	$sp,0,REG_LINK
	.set	noreorder

	lw	mdp_cons,TG_MAC_RECV_CONS(REG_TRP) # get rx_mac_descr_consumer
	addu	scratch,REG_TDP,tdp_rx_mac_ring_end   # end of rx_mac_ring
	beq	mdp_cons,scratch,wrap		   # check for ring wrap
	addu	scratch,mdp_cons,8		   # no, bump to next one
	sw	scratch,TG_MAC_RECV_REF(REG_TRP)   # save new reference
	jr	REG_LINK
	sw	scratch,TG_MAC_RECV_CONS(REG_TRP)  # save new consumer
wrap:	
	addu	scratch,REG_TDP,tdp_rx_mac_ring	   # start of rx_mac_ring
	sw	scratch,TG_MAC_RECV_REF(REG_TRP)   # save new reference
	jr	REG_LINK
	sw	scratch,TG_MAC_RECV_CONS(REG_TRP)  # save new consumer

/* remove local regs */
#undef mdp_prod
#undef scratch

	.set	reorder
	.end	deq_mac_rx

	.ent	deq_mac_rx_end
	.frame	$sp,0,REG_LINK
	.set	noreorder
deq_mac_rx_end:
	jr	REG_LINK
	nop
	.set	reorder
	.end    deq_mac_rx_end

#if 0				/* not yet */
	.ent	h_recv_bd_ready

/* local registers for h_recv_bd_ready */
#define scratch            $2
#define scratch2           $3
#define nentries	   $8
#define recv_cons_index    $9
#define to_move		   $10
#define recv_prod_index_qd $12
#define recv_prod_index    $13
#define next_index         $16
		
/* local stack offsets */
#define save_next_index   36		
#define save_link         40

/* local parm values */	
#define parm5		16($sp)
#define parm6		20($sp)
#define parm7		24($sp)

h_recv_bd_ready:	
	.frame	$sp,48,REG_LINK
	.set	noreorder

	subu	$sp,$sp,48
	sw	REG_LINK,save_link($sp)
	lw	recv_prod_index_qd,nicfp_recv_prod_index_qd(REG_NICFP)
	lw	recv_prod_index,nicfp_recv_prod_index(REG_NICFP)
	sw	next_index,save_next_index($sp)
	
	/* if (nicfp->recv_prod_index_queued == nicfp->recv_prod_index) */
	beq	recv_prod_index_qd,recv_prod_index,clear_recv_bd_event
	/*     nentries = nicfp->recv_prod_index - nicfp->recv_prod_index_qd */
	subu	nentries,recv_prod_index,recv_prod_index_qd
	lw	recv_cons_index,nicfp_recv_cons_index(REG_NICFP)
	/*     if (nentries) < 0) */
	bltzl	nentries,bd_rdy_nowrap
	/*         nentries += RECV_STANDARD_RING_ENTRIES */
	addu	nentries,nentries,RECV_STANDARD_RING_ENTRIES
	
bd_rdy_nowrap:	/* calculate space left in ring */
	sltu	scratch,recv_prod_index_qd,recv_cons_index
	bne	scratch,REG_ZERO,notend
	li	scratch,RECV_STANDARD_RING_ENTRIES
	j	continue
	subu	to_move,scratch,recv_prod_index_qd

notend:	
	subu	to_move,recv_cons_index,recv_prod_index_qd
	addu	to_move,to_move,-1
		
continue: /* tomove = MIN(space, nentries) */
	slt	scratch,nentries,to_move
	bnel	scratch,REG_ZERO,use_space
	move	to_move,nentries

use_space: /* if (!(*nicfp->q_dma_to_nic_stub)(...) */
	addu	next_index,to_move,recv_prod_index_qd
	andi	next_index,next_index,RECV_STANDARD_RING_ENTRIES-1
	lw	parm2,nicfp_recv_ring_ptr_lo(REG_NICFP)
	lw	parm1,nicfp_recv_ring_ptr_hi(REG_NICFP)
	sll	scratch,recv_prod_index_qd,5	   # times sizeof(recv_bd)
	addu	parm2,parm2,scratch
	li	parm3,nicp_recv_ring
	addu	parm3,parm3,scratch
	addu	parm3,REG_NICP,parm3
	sll	parm4,to_move,5			   # times sizeof(recv_bd)
	li	scratch2,(1 << 12)
	sw	scratch2,parm5
	lw	scratch2,nicfp_q_dma_to_nic_stub(REG_NICFP)
	sw	next_index,parm6
	lw	scratch,nicfp_dma_to_nic_bd_state(REG_NICFP)
	jalr	REG_LINK,scratch2
	sw	scratch,parm7

	beq	RETURN_CODE,REG_ZERO,h_recv_bd_ready_return
	/* restore return reg */
	lw	REG_LINK,save_link($sp)
	/* nicfp->recv_prod_index_queued = next_index */
	sw	next_index,nicfp_recv_prod_index_qd(REG_NICFP)

h_recv_bd_ready_return:	
	beq	next_index,recv_prod_index,clear_recv_bd_event
	lw	next_index,save_next_index($sp)
	jr	REG_LINK
	addu	$sp,$sp,48

clear_recv_bd_event:				   # only runs on CPU A
	/* get lock */
	sw	REG_ZERO,TG_SEMAPHORE_A(REG_TRP)
	lw	scratch,TG_SEMAPHORE_A(REG_TRP)
	nop
	beq	scratch,REG_ZERO,clear_recv_bd_event

	/* clear event */
	lw	scratch,TG_EVENT(REG_TRP)
	li	scratch2,not_TG_FW_EVENT_RECV_BD
	and	scratch,scratch,scratch2
	sw	scratch,TG_EVENT(REG_TRP)

	/* free lock */
	sw	REG_ZERO,TG_SEMAPHORE_A(REG_TRP)

	jr	REG_LINK
	addu	$sp,$sp,48
	
/* remove local regs */
#undef scratch
#undef scratch2
#undef nentries
#undef recv_cons_index
#undef to_move
#undef recv_prod_index_qd
#undef recv_prod_index
#undef next_index

/* local stack offsets */
#undef save_next_index
#undef save_link

/* local parm values */	
#undef parm5
#undef parm6
#undef parm7
	
	.set	reorder
	.end	h_recv_bd_ready

	.ent	h_recv_bd_ready_end
	.frame	$sp,0,REG_LINK
	.set	noreorder
h_recv_bd_ready_end:	
	jr	REG_LINK
	nop
	.set	reorder
	.end    h_recv_bd_ready_end

	.ent	h_dma_wr_assist

/* local registers */
#define scratch            $2
#define scratch2           $3
#define ref_cons           $4
#define ref_ring_end       $5
#define reg_dd_type        $6
#define ddp                $7
		
h_dma_wr_assist:	
	.frame	$sp,0,REG_LINK
	.set	noreorder

        /* nicfp->wr_dma_free_cnt++; */
	/* ddp = trp->host_dma_assist.write_chan_ref; */
	lw	scratch,nicfp_wr_dma_free_cnt(REG_NICFP)
	lw	ddp,TG_WRITE_HI_REF(REG_TRP)
	addu	scratch,scratch,1
	sw	scratch,nicfp_wr_dma_free_cnt(REG_NICFP)

        /* nicfp->wr_dma_ref_cons = ref_cons
	       = get_next_wr_dma_ref(nicfp->wr_dma_ref_cons); */
	li	ref_ring_end,0x00010000	      # 65536
	lw	ref_cons,nicfp_wr_dma_ref_cons(REG_NICFP)
	ori	ref_ring_end,ref_ring_end,nicp_wr_dma_ref_ring_end
	addu	ref_ring_end,REG_NICP,ref_ring_end
	bnel	ref_cons,ref_ring_end,wr_assist_nowrap
	addu	ref_cons,ref_cons,8

	addi	ref_cons,ref_ring_end,nicp_wr_dma_ref_ring-nicp_wr_dma_ref_ring_end

wr_assist_nowrap:
	/* ref_cons->type = TIGON_TYPE_NULL; */
	/* dd_type = ddp->type; */
	/* if (ref_cons == nicfp->wr_dma_ref_prod) { */
	lw	scratch,nicfp_wr_dma_ref_prod(REG_NICFP)
	sw	ref_cons,nicfp_wr_dma_ref_cons(REG_NICFP)
	lw	reg_dd_type,dd_type(ddp)
	bne	ref_cons,scratch,more_to_do
	sw	REG_ZERO,0(ref_cons)

	/*     trp->host_dma_assist.write_chan_ref = ddp + 1; */
	addu	scratch,ddp,32
	j	wr_assist_cont
	sw	scratch,TG_WRITE_HI_REF(REG_TRP)

more_to_do:
	/* ref_cons = get_next_wr_dma_ref(nicfp->wr_dma_ref_cons); */
	bnel	ref_cons,ref_ring_end,wr_assist_nowrap2
	addu	ref_cons,ref_cons,1

	addi	ref_cons,ref_ring_end,nicp_wr_dma_ref_ring-nicp_wr_dma_ref_ring_end

wr_assist_nowrap2:
	/* trp->host_dma_assist.write_chan_ref = ddp + ref_cons->count; */
	lw	scratch,4(ref_cons)
	/* ref_cons->type = TIGON_TYPE_NULL; */
	sw	REG_ZERO,0(ref_cons)
	sll	scratch,scratch,5	      # * 32
	addu	scratch,ddp,scratch
	sw	scratch,TG_WRITE_HI_REF(REG_TRP)

wr_assist_cont:
#define mhc	$8
	/* if (dd_type & WR_DMA_GROUP_1) { */
	andi	scratch,reg_dd_type,WR_DMA_GROUP_1
	beq	scratch,REG_ZERO,wr_assist_return
	andi	scratch,reg_dd_type,TIGON_TYPE_TX_CONS
	
        /* if (((dd_type & TIGON_TYPE_TX_CONS) &&
                  !is_global_flags(GF_MOD_DONT_RUPT_SENDS)) ||
              ((dd_type & TIGON_TYPE_RX_PROD) &&
                  !is_global_flags(GF_MOD_DONT_RUPT_RECVS)) ||
              ((dd_type & TIGON_TYPE_EVENT_PROD) &&
                  !is_global_flags(GF_MOD_DONT_RUPT_EVENTS))) { */
	beq	scratch,REG_ZERO,chk_rx_prod
	li	scratch,GF_MOD_DONT_RUPT_SENDS
	and	scratch,REG_GLOBAL_FLAGS,scratch
	beql	scratch,REG_ZERO,wr_assist_rupt
	lw	mhc,TG_MISC_HOST_CONTROL(REG_TRP)

chk_rx_prod:
	andi	scratch,reg_dd_type,TIGON_TYPE_RX_PROD
	beq	scratch,REG_ZERO,chk_evt_prod
	li	scratch,GF_MOD_DONT_RUPT_RECVS
	and	scratch,REG_GLOBAL_FLAGS,scratch
	beql	scratch,REG_ZERO,wr_assist_rupt
	lw	mhc,TG_MISC_HOST_CONTROL(REG_TRP)

chk_evt_prod:
	andi	scratch,reg_dd_type,TIGON_TYPE_EVENT_PROD
	beq	scratch,REG_ZERO,wr_assist_return
	li	scratch,GF_MOD_DONT_RUPT_EVENTS
	and	scratch,REG_GLOBAL_FLAGS,scratch
	bne	scratch,REG_ZERO,wr_assist_return
	lw	mhc,TG_MISC_HOST_CONTROL(REG_TRP)

wr_assist_rupt:
	/* interrupt_host_w_avoidance(); */
        /* if (is_host_in_interrupt_handler()) { */
	lw	scratch2,TG_MBOX0_LOW
	andi	mhc,mhc,TG_MHC_RUPT_STATE
	bne	mhc,REG_ZERO,avoided
	lw	scratch,gen_com_maskRupts
	
	bne	scratch2,REG_ZERO,avoided
	nop

#undef mhc
#define mlc	$8
	bne	scratch,REG_ZERO,avoided
	lw	mlc,TG_MISC_LOCAL_CONTROL(REG_TRP)
	lw	scratch,stats_nicInterrupts(REG_NICFP)
	ori	mlc,mlc,TG_MLC_SET_INTERRUPT
	sw	mlc,TG_MISC_LOCAL_CONTROL(REG_TRP)
	addu	scratch,scratch,1
	j	REG_LINK
	sw	scratch,stats_nicInterrupts(REG_NICFP)

avoided:
	lw	scratch,stats_nicAvoidedInterrupts(REG_NICFP)
	nop
	addu	scratch,scratch,1
	j	REG_LINK
	sw	scratch,stats_nicAvoidedInterrupts(REG_NICFP)

wr_assist_return:
	j	REG_LINK
	nop	
	
/* remove local regs */
#undef scratch
#undef scratch2
#undef ref_cons
#undef ref_ring_end
#undef reg_dd_type
#undef ddp
#undef mlc

		.set	reorder
	.end	h_dma_wr_assist

	.ent	h_dma_wr_assist_end
	.frame	$sp,0,REG_LINK
	.set	noreorder
h_dma_wr_assist_end:	
	jr	REG_LINK
	nop
	.set	reorder
	.end    h_dma_wr_assist_end

	.ent	h_dma_wr_assist_cksum

/* local registers */
		
h_dma_wr_assist_cksum:	
	.frame	$sp,0,REG_LINK
	.set	noreorder

	
		
	.set	reorder
	.end	h_dma_wr_assist_cksum

	.ent	h_dma_wr_assist_cksum_end
	.frame	$sp,0,REG_LINK
	.set	noreorder
h_dma_wr_assist_cksum_end:	
	jr	REG_LINK
	nop
	.set	reorder
	.end    h_dma_wr_assist_cksum_end
#endif /* 0 */	

#endif /* USE_ASM */
