#
# COPYRIGHT NOTICE
# Copyright (c) Alteon Networks, Inc. 1996
# All rights reserved
#
# HISTORY
# $Log: start.s $
# Revision snap_ted/2 1999/03/24 00:09:21 ted
# 	Allow firmware build on x86 solaris
# 
# Revision 1.1.2.4  1998/09/30  18:50:22  shuang
# 	change for new 12.3 API
# 	[1998/09/30  18:40:41  shuang]
#
# Revision 1.1.2.3  1998/02/19  01:30:10  suresh
# 	CPU B support
# 	[1998/02/19  01:25:50  suresh]
# 
# Revision 1.1.2.2  1998/01/29  21:56:57  ted
# 	Add startup endian check sequence
# 	[1998/01/29  21:56:43  ted]
# 
# Revision 1.1.2.1  1998/01/14  23:26:01  ted
# 	rearrange directories
# 	[1998/01/14  23:17:56  ted]
# 
# Revision 1.1.2.1  1997/11/19  19:23:24  ted
# 	Support Tigon and Tigon2 in the same driver
# 	[1997/11/19  19:20:02  ted]
# 
# Revision 1.2.2.2  1996/11/05  21:54:33  hayes
# 	Final pre-ODE merge
# 	[1996/11/05  21:52:24  hayes]
# 
# Revision 1.2.2.1  1996/11/01  18:25:10  ted
# 	Add Copyright notice and history
# 	[1996/10/30  00:45:26  ted]
# 
# $EndLog$
#
#
# COPYRIGHT (c) Essential Communication Corp. 1995
# $Source: /projects/rcs/sw/ge/./nic/fw2/common/start.s,v $
# $Revision: 1.1.2.4 $ $Locker:  $
# $Date: 1998/09/30 18:50:22 $ $Author: shuang $ $State: Exp $
#
	.file	1 "start.s"
	.globl	_start
	.ent	_start
	.set	noreorder
_start:
	nop			# the following sequence detects byte/word
	beq	$0,$0,real_start # swapping failures
	nop			# byte swap only: PC at 4002, invalid inst.
	halt			# word swap only: PC at 4004 due to a halt
	halt			# Byte and word swap: PC at 4003, invalid inst.
real_start:	
	lw	$sp,stack_start	# start stack after aligned data
	move	$fp,$sp		# frame pointer goes to the same place
	la	$16,_start	# save _start in s0 for some reason	
	jal	main_without__main	# jump to main program
	nop
	halt			# stop the processor, never come here
	.end	_start

#
# init routine for CPU B
#
        .globl  _start_b
        .ent    _start_b        # entry point for CPU B
_start_b:
        lw      $sp,stack_start_b # start stack after aligned data
        move    $fp,$sp         # frame pointer goes to the same place
        la      $16,_start    # save _start_b in s0 for some reason
        jal     main_b          # jump to main program
        nop
        halt                    # stop the processor, never come here
        .end    _start_b
