/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1998
 * All rights reserved
 *
 */
/*
 * HISTORY
 * $Log: CElf.h,v $
 * Revision 1.1.2.2  1998/12/22  03:14:07  tibor
 * 	named section changes
 * 	[1998/12/22  02:13:16  tibor]
 *
 * Revision 1.1.2.1  1998/06/02  04:57:17  tibor
 * 	libutils.a interface routines, elf file read object
 * 	[1998/06/02  02:07:13  tibor]
 * 
 * $EndLog$
 */
#ifndef _CELF_H
#define _CELF_H

#include "sys/types.h"
#include "kernelImage.h"

/* CElf error codes, also 0 returned from new_* is an error */
#define CELF_E_MALLOC 		-1  /* malloc returned 0 */
#define CELF_E_PARM 		-2  /* int/user parameter error */
#define CELF_E_FILE_NOTFND	-10 /* file or directory not found */
#define CELF_E_IO_ERROR		-13 /* other file error */
#define CELF_E_INVALID_FMT	-14 /* */

typedef struct elfSection {
    char *name;			/* section name */
    unsigned long bfdflags;	/* saved bfd style flags */
    unsigned char nSecType;	/* type of section uses SECTION_DEF_TYPE_xxxx */
    unsigned char bSecFlags;	/* special section flags SECTION_DEF_FLAG_xxxx */
    unsigned char   reserved_1[2];
    caddr_t addr;		/* section start addr in nl format */
    int  len;			/* section length, data padded to word,  */
    unsigned char *data;	/* actual data block */
} elfSection_t;

typedef struct elfFileData {
    char *fName;
    caddr_t  startAddr;		/* prog start in nl format */
    int  numSections;		/* number of sections */
    elfSection_t **pSecList;	/* list of sections, sorted by section start addr50 */
} elfFileData_t;

extern elfFileData_t *new_elfFileData(char *fName);
extern int read_elfFileData(elfFileData_t *filedata);
extern void free_elfFileData(elfFileData_t *filedata);

#endif /*  _CELF_H */
