/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1998
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: parseTools.h,v $
 * Revision 1.1.2.1  1998/06/19  08:03:00  tibor
 * 	new flash generation conventions
 * 	[1998/06/19  08:00:44  tibor]
 *
 * $EndLog$
 */

#ifndef _PARSETOOLS_H_
#define _PARSETOOLS_H_

/*
 * definition of a #defin token/value pair used by parseFile().  a null
 * symbol defines end of list
 */
typedef struct symbolElement {
    char *pSymbol;
    bool bValid;
    unsigned char nType;
    unsigned char dum[2];
    unsigned long value;
} symbolElement_t;

#define SYMTYPE_CHAR	0x10
#define SYMTYPE_INT	0x20
#define SYMTYPE_INT_DEC 0x21
#define SYMTYPE_INT_HEX 0x22
#define SYMTYPE_STRING  0x30

#define SYMBOLELEMENT(_name, _type) {_name, 0, _type, {0,0}, 0}

int processComment(FILE *pFile, int *nLine, char *pLine, char **pCur);
int processString(FILE *pFile, int *nLine, char *pLine, char **pCur, char **Str);

#endif /* _PARSETOOLS_H_ */
