/*
 * COPYRIGHT NOTICE
 * Copyright (c) Alteon Networks, Inc. 1998
 * All rights reserved
 * 
 */
/*
 * HISTORY
 * $Log: CMedia_int.h,v $
 * Revision 1.1.2.3  1998/12/22  03:14:27  tibor
 * 	named section changes
 * 	[1998/12/22  02:13:20  tibor]
 *
 * Revision 1.1.2.2  1998/06/19  07:55:44  tibor
 * 	moved, renamed CFlash to CMedia, bug fixes
 * 	[1998/06/19  07:44:14  tibor]
 * 
 * Revision 1.1.2.1  1998/06/02  04:57:32  tibor
 * 	new genflash routines
 * 	[1998/06/02  02:33:02  tibor]
 * 
 * $EndLog$
 */

/*
 * Private CMedia methods
 *
 *  These methods and classes are for CMedia internal use only
 */

extern mediaRegionImage_t *new_mediaRegionImage(imageDefinition_t *pDef);
extern mediaRegionObject_t *new_mediaRegionObject(imageDefinition_t *pDef, int nRegionNum);
extern imageObject_t *new_imageObject(U32 nImageType, imageDefinition_t *pDef);
extern imageBlock_t *new_imageBlock();

/* object destructor methods */
extern void free_mediaRegionImage(mediaRegionImage_t *pObj);
extern void free_mediaRegionObject(mediaRegionObject_t *pObj);
extern void free_imageObject(imageObject_t *pObj);
extern void free_imageBlock(imageBlock_t *pObj);

/* object initialization methods */
extern int init_mediaRegionImage(mediaRegionImage_t *pObj, imageDefinition_t *pDef);
extern int init_mediaRegionObject(mediaRegionObject_t *pObj, const imageMapEntry_t *pMap, int setNum);
extern int init_imageKernelObject(imageObject_t *pObj, const imageMapEntry_t *pMap, elfFileData_t *pElf);
extern int init_imageBootObject(imageObject_t *pObj, const imageMapEntry_t *pMap, elfFileData_t *ElfList[]);
extern int init_imageObject(imageObject_t *pObj, const imageMapEntry_t *pMap, elfFileData_t *ElfList[]);
extern int init_imageBlock(imageBlock_t *pObj, int nSize);

/* build methods */
extern int build_mediaObject(mediaObject_t *pObj);
extern int build_imageKernelObject(imageObject_t *pObj, elfFileData_t *pElf);
extern int build_imageBootObject(imageObject_t *pObj, elfFileData_t *ElfList[]);
extern int build_imageObject(imageObject_t *pObj, elfFileData_t *ElfList[]);

/* fill methods */
int fill_regionSet(regionSet_t *pObj);

/* write methods */
extern int write_mediaRegionObject(mediaRegionObject_t *pObj, int offset, int mode, U8 *pSrc, int len);
extern int write_regionSet(regionSet_t *pObj, int offset, int mode, U8 *pSrc, int len);

/* dump methods */
extern int dump_mediaRegionObject(mediaRegionObject_t *pObj, FILE *pFile, int typeDump, int typeWrite);

/* copy methods */
extern U8 *copyElf_imageBootObject(media_code_offset_region_t *pReg, U8 *pBase,
				   U8 *pLimit, elfFileData_t *pElf);
extern U8 * copyElf_imageKernelObject(elfSection_t *pElfSec, section_def_t *pSecDef,
				      U8 *pLoc, U8 *pLimit, U32 *pCrc);
